> For the complete documentation index, see [llms.txt](https://docs.peoplelogic.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.peoplelogic.dev/guides/getting-started-with-the-talent-agent-sdk/working-with-documents/document-listeners.md).

# Document Listeners

The `DocumentListener` interface allows your custom code to be alerted when batches of Document sections have been processed or when the whole batch of Documents has been completed.&#x20;

{% hint style="info" %}
Remember, a single file that was uploaded will be broken down into many Document objects depending on the DocumentProcessors that run on it.
{% endhint %}

{% code title="DocumentListener.java" %}

```java
public interface DocumentListener {
    default void documentBatchIngestStarted(List<Document> batch) {};
    default void documentBatchIngestFinished(List<Document> batch) {};
    default void documentIngestionComplete(List<List<Document>> batch) {};
}
```

{% endcode %}

Here's a very simple pseudo-code example within a tool where we are taking a file from the filesystem, ingesting it through our ContentRetriever and waiting for everything to be completely finished:

```java
AtomicBoolean finishedLoading = new AtomicBoolean(false);
public void doWork() {
    byte[] byteArray = file.getContentAsByteArray();
    
    contentRetriever.ingestDocument(fileName, byteArray);
    
    while (!finishedLoading.get()) {
        log.info("Still loading...");
        Thread.sleep(2500);
    }
}

@Override
public void documentIngestionComplete(List<List<Document>> batch) {
    log.info("Finished processing demand attachments. Ready to continue.");
    finishedLoading.set(true);
}
```

Other use cases might use these listeners to call a webhook or send an actual notification.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.peoplelogic.dev/guides/getting-started-with-the-talent-agent-sdk/working-with-documents/document-listeners.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
